{ config, pkgs, lib, ... }:

{

  config = lib.mkIf (config.genode.boot.storeBackend == "memory") {

    genode.core.children.eris_vfs = {
      package = pkgs.genodePackages.vfs;
      configFile = pkgs.writeText "rom-vfs.dhall" ''
        let Sigil = env:DHALL_SIGIL

        let VFS = Sigil.VFS

        in  ${./rom-vfs.dhall}
              Sigil.Init.Resources::{=}
              ( VFS.vfs
                  [ VFS.leafAttrs
                      "tar"
                      ( toMap
                          { name =
                              "${config.system.build.tarball}/tarball/${config.system.build.tarball.fileName}.tar"
                          }
                      )
                  ]
              )
      '';
    };

    genode.core.children.eris_rom = {
      package = pkgs.genodePackages.cached_fs_rom;
      configFile = ./cached_fs_rom.dhall;
    };

  };

}
